/*
 * $Id: main.c,v 1.14 2002/04/08 07:56:05 nletwory Exp $
 */

#include "yleiset.h"
#include "ajastin.h"

#include <stdio.h>

/* dataa */
#include "gfx.h"


int debug = 0;
int dump = 0;
DATAFILE* datfile;

BITMAP* buf[3];
BITMAP* tausta;
BITMAP* valot;
BITMAP* auto_bmp;
BITMAP* ihmis_bmp;
BITMAP* talo_bmp;

BITMAP* pieni_vw_vasen;
BITMAP* pieni_vw_oikea;

fixed vieri;
int vieritty = 0;
int kerroin = 1;
int resetointi = 0;

int volkkari_x = 300;
int volkkari_y = 314;

int volkkarit = 3;

int kolari = 0;
int tappo = 0;
int bonus = 0;

int yleisvalo = 90;
int valo_lisays = 0;

int poistu_pelista = 0;
int kuollut = 0;

int saadut_bonukset = 0;

int aani = 0;
int vroom_aani;

COLOR_MAP *valokartta;
COLOR_MAP *vari_lisays_kartta;
COLOR_MAP *harmaa_lisays_kartta;

int bufswitch;

olio* lista = NULL;

extern olio *taso_yksi;
extern int taso_yksi_pituus;

/* blender function for creating the additive color table - from RTL-demo by Shawn Hargreaves */
void add_blender(AL_CONST PALETTE pal, int x, int y, RGB *rgb)
{
   int r, g, b;

   r = (int)pal[x].r + (int)pal[y].r;
   g = (int)pal[x].g + (int)pal[y].g;
   b = (int)pal[x].b + (int)pal[y].b;

   rgb->r = MIN(r, 63);
   rgb->g = MIN(g, 63);
   rgb->b = MIN(b, 63);
}

int alusta(void) {

	int i,x,y;

	BITMAP* ruoho, *katu;

	PACKFILE* tmp;
	
	int dat_pituus = 146813;

	loki("alustus\n");

	allegro_init();
	install_timer();
	install_keyboard();

	set_color_depth(8);

	/* asetetaan ensin graafinen tila */
	if(set_gfx_mode(GFX_AUTODETECT,SW,SH,0,0)<0) {
		loki("vaikeuksia asettaa graafinen tila\n");
		return (-1);
	} else {
		loki("graafinen tila asetettu\n");
	}
	enable_triple_buffer();
	text_mode(-1);

	/* luodaan datatiedosto */
	tmp = pack_fopen("data.dat",F_WRITE);
	loki("data.dat avattu ja kirjoitetaan...");
	for(i = 0; i< dat_pituus; i++) {
		pack_putc(data[i],tmp);
	}
	loki(" [ok]\n");
	pack_fclose(tmp);

	if(1) { //////////////////////////////////////
		/* luetaan datatiedosto muistiin */
		datfile = load_datafile("data.dat");
		if(datfile==NULL) {
			loki("%s: %d -> datatiedoston lataaminen eponnistui\n",__FILE__,__LINE__);
			return(-1);
		} else {
			loki("datatiedosto ladattu\n");
		}

		remove("data.dat");

		/* alustetaan sfx osuus */
		if(detect_digi_driver(DIGI_AUTODETECT)>0) {
			aani=1;
		}
		if(aani) {
			detect_midi_driver(MIDI_NONE);

			reserve_voices(4,0);
			set_volume_per_voice(2);

			if(install_sound(DIGI_AUTODETECT,MIDI_NONE,NULL)==0) {
				aani = 1;
				vroom_aani = allocate_voice((AL_CONST SAMPLE *)datfile[SFX_VROOM].dat);
				voice_set_playmode(vroom_aani, PLAYMODE_LOOP|PLAYMODE_BIDIR);
				voice_set_frequency(vroom_aani, 1000+kerroin*125);
				voice_set_volume(vroom_aani,240);
			} else {
				aani = 0;
			}
		}

		/* luodaan bittikartat muistiin */
		buf[0] = create_bitmap(SW,SH);
		buf[1] = create_bitmap(SW,SH);
		buf[2] = create_bitmap(SW,SH);
		valot = create_bitmap(SW,SH);

		if(buf[0]==NULL || buf[1]==NULL || buf[2]==NULL || valot==NULL) {
			loki("%s: %d -> bittikarttojen luonti eponnistui\n",__FILE__,__LINE__);
			return(-1);
		}

		bufswitch = 0;

		ruoho = create_bitmap(214,524);
		katu = create_bitmap(214,524);
		tausta = create_bitmap(SW,524);

		pieni_vw_vasen = create_bitmap(50,70);
		pieni_vw_oikea = create_bitmap(50,70);

		clear(pieni_vw_vasen);
		clear(pieni_vw_oikea);


		if(ruoho==NULL || katu==NULL || tausta==NULL) {
			loki("%s: %d -> bittikarttojen luonti eponnistui\n", __FILE__,__LINE__);
			return(-1);
		}

		for(x=0;x<7;x++) {
			for(y=0;y<17;y++) {
				blit(datfile[RUOHO].dat,ruoho,0,0,x*32,y*32,32,32);
				blit(datfile[KATU].dat,katu,0,0,x*32,y*32,32,32);
			}
		}

		blit(ruoho,tausta,0,0,0,0,214,524);
		blit(katu,tausta,0,0,214,0,214,524);
		blit(ruoho,tausta,0,0,428,0,214,524);

		stretch_sprite(pieni_vw_oikea,(BITMAP *)datfile[AUTO].dat,0,0,50,70);
		pieni_vw_vasen = pieni_vw_oikea;

		destroy_bitmap(ruoho);
		destroy_bitmap(katu);

		((RGB *)datfile[PALETTI].dat)[0] = black_palette[0];
		set_palette((AL_CONST RGB*)datfile[PALETTI].dat);

		valokartta = malloc(sizeof(COLOR_MAP));
		create_light_table(valokartta, (AL_CONST RGB*)datfile[PALETTI].dat, 10, 10, 10, NULL);
	
		vari_lisays_kartta = malloc(sizeof(COLOR_MAP));
		create_color_table(vari_lisays_kartta, (AL_CONST RGB*)datfile[PALETTI].dat, add_blender,NULL);

		harmaa_lisays_kartta = malloc(sizeof(COLOR_MAP));
		for(x=0; x<256; x++)
		{
			for(y=0;y<256;y++)
			{
				harmaa_lisays_kartta->data[x][y] = MIN(x+y,255);
			}
		}

		sekunti_piste=1;

		// asetetaan ajastimet
		LOCK_VARIABLE(fps_laskuri);
		LOCK_VARIABLE(fps_maara);
		LOCK_VARIABLE(kolari);
		LOCK_VARIABLE(sekunti_piste);
		LOCK_FUNCTION(fps);
	
		LOCK_VARIABLE(uudista);
		LOCK_FUNCTION(uudista_ajastin);
		if(install_int_ex(fps,MSEC_TO_TIMER(1000))<0) {
			loki("%s: %d -> fps ajastimen asetus eponnistui\n",__FILE__,__LINE__);
			return(-1);
		}
		if(install_int_ex(uudista_ajastin,BPS_TO_TIMER(60))<0) {
			loki("%s: %d -> uudista_ajastin ajastimen asetus eponnistui\n",__FILE__,__LINE__);
			return(-1);
		}
	} //////////////////////////////////////////////

	loki("taso_yksi_pituus: %d\n",taso_yksi_pituus);

	lista = lue_taso(lista);

	kirjoita_taso(lista);

	if(aani) {
		play_sample((AL_CONST SAMPLE *)datfile[SFX_BUGDRIVE].dat,128,128,1000,0);
	}
	
	return 0;
}

void varoitus() {
	set_palette(black_palette);
	textprintf_centre(buf[bufswitch],(FONT *)datfile[FORTE].dat,320,220,6,"THAT IS NO WAY TO BEHAVE IN TRAFFIC!");
	textprintf_centre(buf[bufswitch],(FONT *)datfile[FORTE].dat,320,240,6,"RESPECT YOUR FELLOW CITIZENS' CARS!");
	blit(buf[bufswitch],screen,0,0,0,0,640,480);
	fade_in((AL_CONST RGB*)datfile[PALETTI].dat,3);

	for(;;) {
		if(key[KEY_SPACE] || key[KEY_ENTER]) {
			fade_out(5);
			return;
		}
	}
}

void piirra(void) {

	int tv,y,x;
	unsigned char *s1, *l, *d;

	tv = (int)(vieri)%524;

	if(tv<0)
		tv += 524;

	acquire_bitmap(buf[bufswitch]);

	blit(tausta,buf[2],0,0,0,H-tv,SW,H);
	blit(tausta,buf[2],0,0,0,-tv,SW,H);
	piirra_olio(lista, buf[2]);

	clear_to_color(valot,yleisvalo);
	color_map = harmaa_lisays_kartta;
	drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
	piirra_olion_valo(lista,valot);
	draw_trans_sprite(valot,datfile[AUTOVALO].dat,volkkari_x-50,volkkari_y-90);
	drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
		
	color_map = vari_lisays_kartta;

	masked_blit(datfile[AUTO].dat,buf[2],0,0,volkkari_x,volkkari_y,50,100);

	/* muokattu versio Shawnin RTL-demosta */
	for(y=0; y<SCREEN_H;y++) {
		s1 = buf[2]->line[y];
		l = valot->line[y];
		d = buf[bufswitch]->line[y];
		
		for(x=0; x<SCREEN_W;x++) {
			d[x] = valokartta->data[l[x]][s1[x]];
		}
	}

	if(debug) {
		textprintf(buf[bufswitch],font,10,10,-1,"fps: %d",fps_maara);
		textprintf(buf[bufswitch],font,10,20,-1,"pisteet: %d", sekunti_piste);
		textprintf(buf[bufswitch],font,10,30,-1,"vieri: %d, vieritty: %d", (int)vieri, vieritty);
		textprintf(buf[bufswitch],font,10,40,-1,"tv: %d", tv);
		textprintf(buf[bufswitch],font,10,50,-1,"kerroin: %d", kerroin);
		textprintf(buf[bufswitch],font,10,60,-1,"volkkari_x: %d, volkkari_y: %d", volkkari_x, volkkari_y);
		if(kolari) {
			textprintf(buf[bufswitch],font,10,70,-1,"pum");
			textprintf(buf[bufswitch],font,40,70,-1,"auh");
			textprintf(buf[bufswitch],font,100,70,-1,"nami");
		}
	}

	textprintf_centre(buf[bufswitch],(FONT *)datfile[FORTE].dat,320,440,(int)vieri,"CARS LEFT: %d",volkkarit);
	textprintf_centre(buf[bufswitch],(FONT *)datfile[FORTE].dat,320,10,(int)vieri-100,"POINTS: %d",(int)(sekunti_piste*2.5));
	textprintf_centre(buf[bufswitch],(FONT *)datfile[FORTE].dat,320,30,100-(int)vieri,"BONUSES: %d/%d",saadut_bonukset,5);
		
	release_bitmap(buf[bufswitch]);

	vsync();
	blit(buf[bufswitch],screen,0,0,0,0,SW,SH);

	bufswitch = 1 - bufswitch;
	
	fps_laskuri++;

	if(kerroin< (abs(sekunti_piste/15)+1))
		kerroin = abs(sekunti_piste/15) + 1;
	if(kerroin>9)
		kerroin = 9;

	voice_set_frequency(vroom_aani, 500+kerroin*100);

	if(!kolari) {
		if(resetointi) {
			fade_in((AL_CONST RGB*)datfile[PALETTI].dat,3);
			resetointi = 0;
		}
		vieri-= kerroin;
		if(vieri<0)
			vieri=523+vieri;
		vieritty+=kerroin;
	} else {
		// feidaus harmaa-palettiin
		fade_from((AL_CONST RGB*)datfile[PALETTI].dat,(AL_CONST RGB*)datfile[HARMAA].dat,3);


		fade_out(3);

		if(volkkarit>0)
			varoitus();
		else
			poistu_pelista=1;
		vieritty = 0;
		volkkari_x = 300;
		volkkari_y = 314;
		vieri = 0;
		kolari = 0;
		resetointi = 1;
		volkkarit--;
	}
	
	if(vieritty>taso_yksi_pituus)
		vieritty=0;
	uudista = 0;
}

void siivoa(void) {

	/* ky lpi oliolistan, ja tuhoa kaikki */
	poksauta_taso(lista);

	/* aanitavarat hiiteen */
	if(aani) {
		deallocate_voice(vroom_aani);
	}

	if(datfile) {
		unload_datafile(datfile);
		loki("datatiedoston muisti vapautettu\n");
	}

	free(harmaa_lisays_kartta);
	free(vari_lisays_kartta);
	free(valokartta);

	loki("color_mappien muisti vapautettu\n");

	remove_int(fps);
	remove_int(uudista_ajastin);

	loki("ajastimet poistettu\n");

	set_gfx_mode(GFX_TEXT,0,0,0,0);

	loki("\n\nvalmis\n");

	if(!debug) {
		allegro_message("Thanks for playing my SpeedHack 2002a -entry:\n\nBug Drive\n\nLook at http://www.allegro.cc/speedhack for more info\nabout the SpeedHack competition\n\nNathan Letwory\nhttp://www.letwory.net");
	}

}

int avaus_ikkuna(void) {
	set_palette(black_palette);
	blit((BITMAP *)datfile[OTSIKKO].dat, screen, 0,0,0,0, SCREEN_W, SCREEN_H);
	fade_in((AL_CONST RGB*)datfile[PAL_OTSIKKO].dat,3);

	do {
	} while (key[KEY_ESC] || key[KEY_SPACE] || key[KEY_ENTER]);

	for(;;) {
		if(key[KEY_ESC]) {
			
			vieritty = 0;
			volkkari_x = 300;
			volkkari_y = 314;
			vieri = 0;
			kolari = 0;
			resetointi = 1;

			sekunti_piste = 0;
			
			fade_out(5);
			clear(screen);
			return 0;
		}
		if(key[KEY_SPACE] || key[KEY_ENTER]) {
			fade_out(5);
			clear(screen);
			return 1;
		}
		if(key[KEY_F12]) {
			save_bitmap("shotti.bmp",screen,(AL_CONST RGB *)datfile[PAL_OTSIKKO].dat);
		}
	}
}


int main(int argc, char* argv[])
{

	set_uformat(U_ASCII);

	while(--argc > 0) {
		if(ustrcmp("-d",argv[argc])==0) {
			if(!debug) alusta_loki("loki.log");
			debug = 1;
		} else if(ustrcmp("--debug", argv[argc])==0) {
			if(!debug) alusta_loki("loki.log");
			debug = 1;
		} else if(ustrcmp("--dump", argv[argc])==0) {
			dump = 1;
		} else {
			printf("unknown option: %s\n",argv[argc]);
			printf("usage: %s [option]\n",argv[0]);
			printf("\t-d, --debug\t\tcreate a logfile\n");
			return 0;
		}
	}

	loki("debuggaus on pll ja jrjestelm alustetaan:\n\n");
				
	/* alusta koko peli (allegro, gfx, snd, etc.) */
	if(alusta()<0) {
		loki("%s: %d -> alustusongelma!! Lopetetaan kaikki hommat\n", __FILE__,__LINE__);
		exit(-1);
	}
	
	/* psilmukka */
	loki("aloitetaan luuppi...\n");

	/* avaus ikkuna */

	do{
	}while(key[KEY_ESC]);

	voice_start(vroom_aani);

	while(avaus_ikkuna()) {
		fade_in((AL_CONST RGB*)datfile[PALETTI].dat,3);
		voice_start(vroom_aani);
		while(!poistu_pelista) {
			if(key[KEY_ESC]) {
				poistu_pelista = 1;
			}
			if(key[KEY_F12]) {
				save_bitmap("shotti.bmp",buf[bufswitch],(AL_CONST RGB *)datfile[PALETTI].dat);
			}
			if(uudista>0) {
				paivita(lista);
				piirra();
			}
		}
		voice_stop(vroom_aani);
	}


	fade_out(5);

	play_sample((AL_CONST SAMPLE *)datfile[SFX_MADEWITH].dat,128,128,1000,0);

	rest(2500);

	/* loppu ikkuna */

	/* siivoa sotkut */
	loki("jaaha, pelaaja kyllsty peliin... siivoamiseen sitten\n");
	siivoa();
	return 0;
}
END_OF_MAIN()
